=== debian/changelog ===
cpp-httplib (0.26.0+ds-2) experimental; urgency=low

  * Re-do upload, with binaries

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 20 Sep 2025 18:37:50 +0200

cpp-httplib (0.26.0+ds-1) experimental; urgency=medium

  * Update to new upstream version 0.26.0+ds.
  * build(meson): use C++17 for gtest >= 1.17.0
  * d/control: libcpp-httplib0.25 -> libcpp-httplib0.26
  * d/rules: use new option names

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 20 Sep 2025 15:31:16 +0200
